## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 48;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

Name:           ladspa-autotalent-plugins
Version:        0.2
Release:        %autorelease
Summary:        A pitch-correcting LADSPA plugin

# From COPYING:
#
#   Autotalent (autotalent.c) is released under GPL2.  However, the FFT
#   routine was taken from PureData
#   (http://crca.ucsd.edu/~msp/software.html), which was released under a
#   license that is similar to the BSD license.  So with the exception of
#   the mayer_fft.* files, everything should fall under GPL2.  The license
#   pertinent to mayer_fft.* is contained in COPYING-mayer_fft.
#
#   -Tom
#
# The copyright and license statement in the header comment of autotalent.c
# makes clear that GPL-2.0-or-later is intended. The obsolete FSF postal
# address in COPYING, autotalent.c, and Makefile was reported upstream by email
# on 2023-04-26.
#
# The files mayer_fft.h and mayer_fft.c are BSD-3-Clause.
#
# Additionally, ladspa.h is LGPL-2.1-or-later, but it is removed in %%prep and
# is not used in compiling the plugins, so it does not contribute to the
# licenses of the binary RPMs.
#
# The reference card http://tombaran.info/autotalent-%%{version}_refcard.pdf
# was previously packaged as useful documentation. Icons in the bottom right
# corners of the PDF indicate its license is CC-BY-ND, but do not specify a
# version, so we are not able to determine the correct SPDX expression. In any
# case, the CC-BY-ND-* licenses are approved for content but not for
# documentation.
License:        GPL-2.0-or-later AND BSD-3-Clause
SourceLicense:  %{license} AND LGPL-2.1-or-later
URL:            http://tombaran.info/autotalent.html
Source:         http://tombaran.info/autotalent-%{version}.tar.gz

# https://fedoraproject.org/wiki/Changes/EncourageI686LeafRemoval
ExcludeArch:    %{ix86}

BuildRequires:  gcc
BuildRequires:  make

BuildRequires:  ladspa-devel

# For %%{_libdir}/ladspa/
Requires:       ladspa

%description
Autotalent is a real-time pitch correction plugin. You specify the notes that a
singer is allowed to hit, and Autotalent makes sure that they do. You can also
use Autotalent for more exotic effects, making your voice sound like a
chiptune, adding artificial vibrato, or messing with your formants.  Autotalent
can also be used as a harmonizer that knows how to sing in the scale with you.
Or, you can use Autotalent to change the scale of a melody between major and
minor or to change the musical mode.

A reference card is available at:

http://tombaran.info/autotalent-%{version}_refcard.pdf


%prep
%setup -q -n autotalent-%{version}

# Use the system ladspa.h
rm -v ladspa.h
sed -i 's|ladspa.h||' Makefile


%build
# Upstream default CFLAGS:
#   -I. -O3 -Wall -fomit-frame-pointer -fstrength-reduce -funroll-loops
#   -ffast-math -c -fPIC -DPIC
# Of these,
#   -O3 -fomit-frame-pointer -fstrength-reduce -funroll-loops -ffast-math
# are optimization flags. In the spirit of
# https://docs.fedoraproject.org/en-US/packaging-guidelines/#_compiler_flags,
# and in the absence of benchmarks showing their benefit, we omit these, except
# for -ffast-math, which we argue is not a generic optimization flag but a
# statement about the level of floating-point standards-conformance that the
# software is designed to require.
export CFLAGS="-I. ${CFLAGS-} -Wall -ffast-math -c -fPIC -DPIC"
# Upstream default LDFLAGS
#   -nostartfiles -shared -Wl,-Bsymbolic -lc -lm -lrt
# These are generally OK; -lc is not required, and since glibc 2.17, -lrt is
# not needed for clock_* functions. We are not sure exactly what -Wl,-Bsymbolic
# is doing, so we leave it alone.
export LDFLAGS="${LDFLAGS-} -nostartfiles -shared -Wl,-Bsymbolic -lm"

%make_build CC="${CC-gcc}" CFLAGS="${CFLAGS}" LDFLAGS="${LDFLAGS}"


%install
%make_install INSTALL_PLUGINS_DIR='%{buildroot}%{_libdir}/ladspa'


%files
%license COPYING COPYING-mayer_fft
%doc README

%{_libdir}/ladspa/autotalent.so


%changelog
## START: Generated by rpmautospec
* Thu Dec 12 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.2-48
- Add a SourceLicense field

* Thu Jul 18 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.2-47
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Thu Jan 25 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.2-45
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Sun Jan 21 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.2-44
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Thu Jul 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.2-43
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Sat Jun 03 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.2-42
- Remove explicit %%set_build_flags, not needed since F36

* Thu May 04 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.2-40
- Drop i686 support (leaf package)

* Wed Apr 26 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.2-39
- Record that the obsolete FSF postal address was reported upstream

* Wed Apr 26 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.2-38
- Stop unnecessarily globbing in the files list

* Wed Apr 26 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.2-37
- Remove unnecessary include-path patching

* Wed Apr 26 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.2-36
- Update URLs and summary

* Wed Apr 26 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.2-35
- Use RPM make macros and improve handling of build flags

* Wed Apr 26 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.2-34
- Update License to SPDX

* Wed Apr 26 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.2-33
- Drop the PDF reference card due to license issues
- Add an explanatory spec-file comment.

* Wed Apr 26 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.2-32
- Improve spec-file formatting

* Thu Jan 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.2-27
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Thu Jul 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.2-26
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.2-25
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Thu Jul 22 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.2-24
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.2-23
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Tue Jul 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.2-22
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Wed Jan 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.2-21
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.2-20
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Fri Feb 01 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.2-19
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.2-18
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Mon Mar 12 2018 Orcan Ogetbil <oget [DOT] fedora [AT] gmail [DOT] com> - 0.2-17
- Use Fedora link flags
- Add BR: gcc
- Some cleanup

* Wed Feb 07 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.2-16
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Thu Aug 03 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.2-15
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.2-14
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.2-13
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.2-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.2-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sun Aug 17 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.2-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.2-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.2-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.2-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Thu Jul 19 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.2-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.2-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Mon Feb 07 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.2-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Fri May 28 2010 David Cornette <rpm@davidcornette.com> 0.2-3
- Updated to upstream package which includes the license file for the Pure Data
  source files

* Sun May 23 2010 David Cornette <rpm@davidcornette.com> 0.2-2
- Changed License: field to reflect license of the reference card pdf

* Fri May 14 2010 David Cornette <rpm@davidcornette.com> 0.2-1
- Initial build

## END: Generated by rpmautospec
